@use "sass:math";

@import '../../styles/variables';
@import '../../styles/mixins';

.cui-select {
  flex: 1 0 auto;
  max-width: 100%;

  .ng-select {
    flex: 1 0 auto;
    @include cui-text(m);

    .ng-placeholder {
      display: none;
    }

    &:not(.ng-select-searchable) {
      .ng-input {
        opacity: unset !important;

        > input[readonly] {
          width: unset !important;
        }
      }
    }

    .ng-select-container {
      align-items: center;
      border-radius: cui-border-radius(m);
    }

    .ng-value-container {
      align-items: center;
      padding-left: $cui-input-padding-h;


    }

    &.ng-select-single {
      .ng-value-container {
        .ng-input {
          left: 0;
          padding-left: $cui-input-padding-h;
        }
      }

      .ng-has-value input::placeholder {
        color: transparent;
      }
    }

    &.ng-select-multiple {
      .ng-value-container {
        padding-left: 0; //$cui-input-padding-h;

        .ng-value {
          display: flex;
          align-items: center;
          background-color: $cui-select-value-bg-color;
          border-radius: cui-border-radius(m);

          &:hover {
            background-color: $cui-select-value-bg-color-hover;
          }

          &.ng-value-disabled {
            cursor: not-allowed;
            opacity: $cui-disabled-opacity;
          }
        }
      }
    }

    .ng-select-spinner {
      color: $cui-input-placeholder-color;
    }

    .ng-clear-wrapper {
      .ng-clear {
        width: 100%;
        height: 100%;
        overflow: hidden;
        text-indent: -9999rem;
        background-size: contain;
        background-repeat: no-repeat;
        background-position: center;
        // unfortunately ngSelect does not allow a custom clear icon. We need to rebuild our own SVG icons using CSS.
        background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24'%3E%3Cpath fill-rule='evenodd' fill='rgb(105,118,135)' d='M12 2c5.523 0 10 4.477 10 10s-4.477 10-10 10S2 17.523 2 12 6.477 2 12 2zM9.084 7.68a1 1 0 00-1.41 1.397l.083.095L10.586 12l-2.829 2.828-.077.088a1 1 0 001.397 1.41l.095-.083L12 13.414l2.828 2.829.088.077a1 1 0 001.41-1.397l-.083-.095L13.414 12l2.829-2.828.077-.088a1 1 0 00-1.397-1.41l-.095.083L12 10.586 9.172 7.757l-.088-.077z' clip-rule='evenodd'/%3E%3C/svg%3E%0A");
      }

      &:hover .ng-clear {
        // as coloring does not work with inline SVG, we need to rebuild the entire icon to change its color.
        background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24'%3E%3Cpath fill-rule='evenodd' fill='rgb(32,45,64)' d='M12 2c5.523 0 10 4.477 10 10s-4.477 10-10 10S2 17.523 2 12 6.477 2 12 2zM9.084 7.68a1 1 0 00-1.41 1.397l.083.095L10.586 12l-2.829 2.828-.077.088a1 1 0 001.397 1.41l.095-.083L12 13.414l2.828 2.829.088.077a1 1 0 001.41-1.397l-.083-.095L13.414 12l2.829-2.828.077-.088a1 1 0 00-1.397-1.41l-.095.083L12 10.586 9.172 7.757l-.088-.077z' clip-rule='evenodd'/%3E%3C/svg%3E%0A");
      }
    }

    .ng-arrow-wrapper {
      margin-right: $cui-input-padding-h;

      .ng-arrow {
        width: 100% !important;
        height: 100% !important;
        overflow: hidden;
        text-indent: -9999rem;
        background-size: contain;
        background-repeat: no-repeat;
        background-position: center;
        // unfortunately ngSelect does not allow custom dropdown arrow icons. We need to rebuild our own SVG icons using CSS.
        background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24'%3E%3Cpath fill='rgb(105,118,135)' d='M7.39 9.39a1.45 1.45 0 00-1.98 0 1.289 1.289 0 000 1.886l5.6 5.333a1.45 1.45 0 001.98 0l5.6-5.333a1.289 1.289 0 000-1.885 1.45 1.45 0 00-1.98 0L12 13.78 7.39 9.39z'/%3E%3C/svg%3E");
      }

      &:hover .ng-arrow {
        // as coloring does not work with inline SVG, we need to rebuild the entire icon to change its color.
        background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24'%3E%3Cpath fill='rgb(32,45,64)' d='M7.39 9.39a1.45 1.45 0 00-1.98 0 1.289 1.289 0 000 1.886l5.6 5.333a1.45 1.45 0 001.98 0l5.6-5.333a1.289 1.289 0 000-1.885 1.45 1.45 0 00-1.98 0L12 13.78 7.39 9.39z'/%3E%3C/svg%3E");
      }
    }

    &.ng-select-opened {
      .ng-arrow-wrapper {
        .ng-arrow {
          top: -.125rem;
          // as coloring does not work with inline SVG, we need to rebuild the entire icon to change its color.
          background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24'%3E%3Cpath fill='rgb(105,118,135)' d='M16.61 16.61a1.45 1.45 0 001.98 0 1.289 1.289 0 000-1.886l-5.6-5.333a1.45 1.45 0 00-1.98 0l-5.6 5.333a1.289 1.289 0 000 1.885 1.45 1.45 0 001.98 0L12 12.22l4.61 4.39z'/%3E%3C/svg%3E");
        }

        &:hover .ng-arrow {
          // as coloring does not work with inline SVG, we need to rebuild the entire icon to change its color.
          background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24'%3E%3Cpath fill='rgb(32,45,64)' d='M16.61 16.61a1.45 1.45 0 001.98 0 1.289 1.289 0 000-1.886l-5.6-5.333a1.45 1.45 0 00-1.98 0l-5.6 5.333a1.289 1.289 0 000 1.885 1.45 1.45 0 001.98 0L12 12.22l4.61 4.39z'/%3E%3C/svg%3E");
        }
      }
    }
  }
}

.cui-ng-select.ng-dropdown-panel, cui-select .ng-dropdown-panel {
  left: 0;
  padding: $cui-menu-padding-v 0;
  background-color: $cui-menu-bg-color;
  border: 1px solid $cui-input-border-color;
  border-radius: $cui-menu-border-radius;
  box-shadow: $cui-menu-shadow;

  &.ng-select-bottom {
    top: 100%;
    margin-top: .5rem;
  }

  &.ng-select-top {
    bottom: 100%;
    margin-bottom: .5rem;
  }

  .ng-dropdown-header,
  .ng-dropdown-footer {
    padding: $cui-menu-item-padding;
    line-height: $cui-menu-title-line-height;
    font-size: $cui-menu-title-font-size;
    font-weight: 600;
    color: $cui-menu-title-text-color;
  }

  .ng-dropdown-header {
    border-bottom: 1px solid $cui-input-border-color;
  }

  .ng-dropdown-footer {
    border-top: 1px solid $cui-input-border-color;
  }

  .ng-optgroup {
    user-select: none;
    padding: $cui-menu-title-padding;
    line-height: $cui-menu-title-line-height;
    font-size: $cui-menu-title-font-size;
    font-weight: 600;
    color: $cui-menu-title-text-color;
    cursor: pointer;

    &.ng-option-disabled {
      cursor: default;
    }
  }

  .ng-option {
    padding: $cui-menu-item-padding;
    line-height: $cui-menu-item-line-height;
    font-size: $cui-menu-item-font-size;
    color: $cui-menu-item-text-color;

    &.ng-option-disabled {
      opacity: $cui-disabled-opacity;
      cursor: not-allowed;
    }

    &.ng-option-child {
      padding-left: 1.5rem;
    }

    .ng-tag-label {
      font-size: cui-font-size(s);
      padding-right: .5rem;
    }
  }

  // increase specificity
  .ng-dropdown-panel-items .ng-option {
    display: flex;
    align-items: center;
  }

  .ng-option-marked {
    background-color: $cui-menu-item-hover-color;
  }

  .ng-option-selected {
    color: cui-color(primary, text);
  }

  .ng-select-multi-checkbox {
    margin-right: .5rem;
  }
}

// ----- sizes
@mixin styles($size) {
  $btn-width: cui-height($size) * 0.5 + 0.5rem;

  .cui-select .ng-select {
    .ng-select-container {
      min-height: cui-height($size);
    }

    &.ng-select-single {
      .ng-select-container {
        height: cui-height($size);
      }

      .ng-value-container .ng-input {
        top: (cui-height($size) - cui-line-height(m)) * 0.5;
        padding-right: 2 * $btn-width + 2 * $cui-input-padding-h;
      }
    }

    &.ng-select-multiple {
      $height: cui-height($size) * 0.5 + 0.5rem;
      $margin: (cui-height($size) - $height) * 0.5;

      .ng-value-container {
        padding: $margin * 0.5;

        .ng-value {
          line-height: $height;
          margin: $margin * 0.5;
        }

        .ng-value-label {
          padding: 0 (cui-height($size) * 0.2);
        }

        .ng-value-icon {
          margin: 0 (cui-height($size) * 0.1) 0 math.div(cui-height($size), -10);
        }

        .ng-placeholder {
          top: (cui-height($size) - cui-line-height(m)) * 0.5;
          left: $cui-input-padding-h;
        }

        .ng-input {
          padding-left: $cui-input-padding-h - ($margin * 0.5);
        }
      }

      .ng-has-value .ng-input {
        padding-left: ($margin * 0.5);
      }
    }

    .ng-select-spinner {
      margin: $btn-width - cui-height(s) * 0.5;
    }

    .ng-clear-wrapper,
    .ng-arrow-wrapper {
      width: $btn-width;
      height: $btn-width;
      padding: ($btn-width - 1.25rem) * 0.5;
    }
  }
}

@mixin size($size) {
  [data-cui-size='#{$size}'] {
    @include styles($size);
  }
}

@include styles('m');
@include size('s');
@include size('l');
